#ifndef __GENERIC_HELPER_CPP__
#define __GENERIC_HELPER_CPP__

#include <string.h>

// Generic string comparing and other generic functions
// Everything here MUST be memory safe and MUST be C and C++ compatable

//find out if running c++
#ifndef __cplusplus
#include <stdbool.h>
#endif


// compare hostnames for SNI
// ss = serverside name
// cs = clientside name
// strlen(cs) >= strlen(ss)
// ss can have wildcards cs cannot
bool cmphost(char *ss, char *cs){
    int sp=0;
    for (int i=0; i<strlen(cs); i++) {
        if(sp>strlen(ss)){return false;}

        if(ss[sp]=='*' && cs[i]!='.'){continue;}
        if(ss[sp]=='*' && cs[i]=='.'){sp += 2; continue;}
        if(ss[sp]!=cs[i]){return false;}
        sp++;
    }
    return true;
}

#endif